<template>
    <div v-if="innerValueCurrentCustomer">
        <v-card elevation="1" class="admin-content pa-4">
            <v-btn
                color="primary"
                @click="$router.go(-1)"
                class="mb-4"
            >
                <v-icon left>mdi-keyboard-backspace</v-icon>
                Retour
            </v-btn>
            <v-snackbar
                v-model="customerDetailSnackbar"
                :timeout="3000"
                :color="snackbarColor"
            >
                {{snackbarMessage}}
                <template v-slot:action="{ attrs }">
                    <v-btn
                        color="white"
                        text
                        v-bind="attrs"
                        @click="customerDetailSnackbar = false"
                    >
                        Fermer
                    </v-btn>
                </template>
            </v-snackbar>
            <div class="text-h4">Détail client</div>
            <v-form
                ref="form"
                v-model="isFormValid"
                @submit.prevent="submitUpdatedForm"
            >
                <div class="text-h6 mt-6">Informations générales</div>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.firstName"
                            :rules="[$utils.rules.required]"
                            :counter="32"
                            label="Nom"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.lastName"
                            :rules="[$utils.rules.required]"
                            :counter="64"
                            label="Prénom"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-select
                            v-model="innerValueCurrentCustomer.gender"
                            :items="genderSelectItems"
                            label="Gendre"
                        ></v-select>
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.phoneNumber"
                            :rules="[$utils.rules.required]"
                            :counter="64"
                            label="Numéro de téléphone"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.email"
                            :rules="[$utils.rules.required, $utils.rules.email]"
                            label="E-mail"
                            :counter="64"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" sm="4">
                        <v-select
                            v-model="innerValueCurrentCustomer.enabled"
                            :items="enabledSelectItems"
                            label="Statut"
                        ></v-select>
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12" sm="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.dob"
                            type="date"
                            label="Date de naissance"
                        ></v-text-field>
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.createdAt"
                            label="Date de création"
                            disabled
                        />
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12">
                        <v-textarea
                            v-model="innerValueCurrentCustomer.description"
                            label="Description"
                            clearable
                            color="teal"
                        />
                    </v-col>
                </v-row>
                <div class="text-h6 mt-6">Adresse complète</div>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.address"
                            :rules="[$utils.rules.required]"
                            :counter="64"
                            label="Adresse"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.city"
                            :rules="[$utils.rules.required]"
                            label="Ville"
                            :counter="64"
                            required
                            clearable
                        />
                    </v-col>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.postalCode"
                            :rules="[$utils.rules.required]"
                            label="Code postale"
                            :counter="8"
                            required
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-row>
                    <v-col cols="12" md="4">
                        <v-text-field
                            v-model="innerValueCurrentCustomer.country"
                            :rules="[$utils.rules.required]"
                            label="Pays"
                            :counter="64"
                            required
                            clearable
                        />
                    </v-col>
                </v-row>
                <v-btn color="green" type="submit" dark :disabled="!isFormValid">
                    Enregistrer
                </v-btn>
            </v-form>
        </v-card>
        <v-card elevation="1" class="admin-content pa-4">
          <div class="text-h5 mb-4">Débug</div>
          <p>{{ JSON.stringify(innerValueCurrentCustomer) }}</p>
        </v-card>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';
import moment from 'moment';

export default {
    name: 'CustomerDetail',
        data: () => ({
        innerValueCurrentCustomer: null,
        isFormValid: true,
        snackbarMessage: '',
        snackbarColor: '',
        customerDetailSnackbar: false,
        enabledSelectItems: [
            {text: 'Vérifié', value: 1},
            {text: 'En attente', value: 0}
        ],
        genderSelectItems: [
            {text: 'Homme', value: 'men'},
            {text: 'Femme', value: 'women'},
            {text: 'Autre', value: 'other'}
        ],
    }),
    methods: {
        ...mapActions(['loadCustomer', 'updateCustomer']),
        submitUpdatedForm() {
            let dataChanged = this.$utils.getChanges(this.getCurrentCustomer, this.innerValueCurrentCustomer);
            if (!this.$utils.isEmptyObject(dataChanged)) {
                dataChanged.id = this.innerValueCurrentCustomer.id;
                this.updateCustomer(dataChanged)
                    .then(() => {
                        this.snackbarMessage = 'Les données ont été sauvegardées';
                        this.snackbarColor = 'green';
                        this.customerDetailSnackbar = true;
                    })
                    .catch(() => {
                        this.snackbarMessage = this.getCrudError;
                        this.snackbarColor = 'red';
                        this.customerDetailSnackbar = true;
                    });
            } else {
                this.snackbarMessage = 'Les données ont été sauvegardées';
                this.snackbarColor = 'green';
                this.customerDetailSnackbar = true;
            }
        }

    },
    computed: {
        ...mapGetters(['getCurrentCustomer']),
    },
    async mounted() {
        await this.loadCustomer(this.$route.params.customerId);
        this.innerValueCurrentCustomer = Object.assign({}, this.getCurrentCustomer);
        this.innerValueCurrentCustomer.createdAt = moment(this.innerValueCurrentCustomer.createdAt).format('YYYY-MM-DD');
        this.innerValueCurrentCustomer.dob = moment(this.innerValueCurrentCustomer.dob).format('YYYY-MM-DD');
    }
}
</script>

